#! /usr/bin/perl 

# ./fein.pl action=upload file=ags/archiv/$file
# ./fein.pl action=ags file=ags/archiv/$ags8.tab
#use	UTF8;
#no UTF8;
#use strict;
use CGI;
use CGI::Pretty;
use CGI qw/:standard -$debug *table *Tr *form *html *blockquote/ ;
#use CGI qw/:standard  *table *Tr *form *html *blockquote/ ;

$CGI::POST_MAX=1024 *100;	# max 100 KB uploads

use locale;
use encoding "latin1";


my $apath	= "./ags";
my $afile	= "$apath/ags8.tab";
my $lfile	= "$apath/f.log"; # access log
my $sfile	= "$apath/s.log"; # success log
my $a5file	= "$apath/ags5.tab";
my $neufile = "$apath/new.tab";
my $file;
#$cfile  = "$apath/archiv/code_060626.txt";
my $action	= "search";
my $debug	= 0;
my $var	= 0;
my $text	= "6"; # font size for results
my $i		= 0;
my $ii;
#$action	= "upload";
my (@ags,@kz,@ort,@plz,@street,@street2,@status,@streetnr,@ortsteil);
my ($ags,$kz,$ort,$name1,$name2,$str,$hsnr,$jahr,$plz);
my ($ckhags,$ckhort,$ckhkz,$ckhjahr,$ckhtext);
my ($html_style, $html_header, $html_footer);

init();
report_error();
report_use();
if(param('action')) {
	$action = param('action');
	$file	= param('file');
	splitkeys($file) 	if $action =~ /upload/;
	split_ags8($file) 	if $action =~ /ags/;

}


if($ags) {print header(-cookies=>[$ckhags,$ckhort,$ckhkz,$ckhjahr,$ckhtext])}
else {print header()}
# print start_html('ADFC Fachauschuss Technik - Straenschlssel zur Fahrradcodierung');
print $html_style;
print $html_header;

if (access_log()) {
#print h1('Serverberlastung - bitte versuchen Sie es spter wieder');
print "Bitte wenden Sie sich direkt an code\@adfc.de, wenn Sie dringende oder
hufigere Anfragen haben.<br>";

end_html();
die;
}

print "RC:".raw_cookie(),p if $debug;
print "ags: $ags; name: $name;",p,"cookies: $ckhags, $ckhort, $ckhkz",p if $debug;
print "QS: ".query_string,p if $debug;
print "URL: ".url(),p if $debug;
print Dump if $debug;
print start_form;
$ags 	= search_ags ($name) if !$ags;

print start_table({-border=>'0'});
print	start_Tr(),td(b('Ort')),td(textfield('name'));
if ($i==1 or $kz or getname($ags)){
	print	(td(b($kz)), td(($ort)));
} elsif($name) {
	print end_Tr;
	for ($ii=0; $ii<$i; $ii++) {
		print	Tr(
			td(a({href=>url(-relative)."?".
				"ags=$ags[$ii];".
				($str?";str=$str":'').
				($hsnr?";hsnr=$hsnr":'').
				($name1?";n1=$name1":'').
				($name2?";n2=$name2":'')},
				$kz[$ii])),
			td($ort[$ii].
				($plz[$ii]=~ /^(.{17}),/?" (PLZ: $1...)":
				($plz[$ii]?" (PLZ: $plz[$ii])":''))
				)
			);
	}
}
print end_Tr;

print start_Tr(),(td(b('Strae')),td(textfield('str')));
print "suche nach Strasse $ags:$str;\n",p if $debug;;
search_keys ($ags, $str) if $ags;
if($i==0 and param('nr')) {
	$street[0] = $str;
	$streetnr[0] = param('nr');
} elsif ($i==0) {
print "suche nach neuer $ags:$str;\n",p if $debug;;
	search_new($ags,$str);
}

print end_Tr;
#print	Tr(td('optional:'),td(' '));
print	Tr(td('Haus-Nr.'),td(textfield('hsnr')));
print	Tr(td('Vorname'),td(textfield('n1')));
print	Tr(td('Nachname'),td(textfield('n2')));
print	Tr(td,td(submit(-name=>'suchen')));
print	Tr(td,td(defaults(-name=>'lschen'))) if $str;

print end_table();

print h2 ({style=>'color:red;text-align:center'},
	"Die Straennummer $streetnr[0] sollte aus genau fnf Nummern bestehen!?") 
	if $streetnr[0] and $streetnr[0] =~ tr/0-9// != 5 
	and $ags != "02000000"
	and !$ags =~ /^09/; # Ausnahmen Hamburg und Bayern

result();
success_log() if ($ags and $str);

if($i==0 and $str){
	if ($ags =~ /^08/) {
		print h2 ('Es wurde keine passende Codierung gefunden. ').p.
        	'Bitte suchen Sie auf ' .
        	'<a href="http://www.polizei-bw-ein.de/Code.aspx">Polizei-BW: EIN</a>' .
        	' nach aktuelleren Daten und melden diese gegebenfalls an uns zurck', p;
	} elsif ($ags =~ /^09/) {
		print h2 ('Es wurde keine passende Codierung gefunden. ').p.
	        'Bitte wenden Sie sich an den ' .
    	    '<a href="mailto:codierung@adfc-bayern.de">ADFC Bayern</a>' .
        	', der Ihnen den passenden Code nach seinen Landesregeln ermitteln kann. ', p;
    } elsif ($ags =~ /^12/) {
	    print h2 ('Es wurde keine passende Codierung gefunden. ').p.
	        'Bitte suchen Sie auf ' .
    	    '<a href="http://www.geobasis-bb.de/LGB1/service/wsc/index.html">'.
        	'Polizei Brandenburg: Wertsachencodierung</a>' .
        	' nach aktuelleren Daten und melden diese gegebenfalls an uns zurck', p;
	} else {
		print h2 ('Es wurde keine passende Strae gefunden. '.
	    		'Bitte versuchen Sie, nur nach dem Wortanfang zu suchen. '),p ;
	}

	if ($str =~ /(\b.{5}).*([sS]tr\S*\s*)*/ ) {
	print "Oftmals schlgt die Suche fehl, wenn unterschiedliche Schreibweisen existieren. ".
		"Unser Vorschlag: Versuchen Sie noch einmal folgende Suche:".
		h2( {-align=>CENTER},
			a({href=>url(-relative).'?'.
           'ags='.$ags.';'.
           'str='.$1}, b($1))) . p ; }


	if ($action eq 'edit' or param(addnr)) {
	   	add_str();
	} else {
	   print 'Kennen Sie den Straenschlssel einer hier bisher unbekannten Strae?
	       nderungen knnen sie ' .
	       a({href=>url(-relative).'?'.
					'ags='.$ags.';'.
					'str='.$str.';'.
					'action=edit'}, 'hier sofort eingeben') 
		.'.';
	}
} elsif ($i==1 and $streetnr[0] ) {
    print hr, 'Haben Sie einen anderen Code erwartet als den von uns ermittelten? 
        Bitte setzen Sie sich unbedingt mit uns in Verbindung, wenn Sie andere
        Straenschlssel kennen.', p;
    print 'Lob und Tadel nehmen wir immer dankbar auf. Bitte schicken Sie Ihre 
        Ideen an <a href="mailto:code@adfc.de">code@adfc.de</a>' , p;
}
print end_form(), $html_footer, end_html();

# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub result {
my $tresult='';
my $aresult='';

my $mykz;
my $myags;
my $myhsnr;
my $myini;
my $myjahr;
my $myein;
print "kz;$kz str:$streetnr[0] hs:$hsnr ini:$name1 $name2 yy:$jahr i:$i text:$text " . (localtime) if $debug;
return '0' if $i != 1 or !$street[0];

# print hr;

# fake output for Markus
$streetnr[0] = $streetnr[0] + int(rand(20000)) if user_agent() eq "Mozilla/4.0 (compatible; MSIE 6.0; Windows 98)"; 

($mykz,$myags) = $kz =~ /([A-Z]+) ([-0-9]+)/;
if ($hsnr) {
	$myhsnr = ($hsnr =~ /^ *([0-9]+)/?"00".$1:"?");
	$myhsnr =~ s/\d*(\d{3})$/$1/;
}
if ($name1 or $name2) {
    if ($name1 =~ /^ *[A-Z]/ and $name2 =~ /^ *[A-Z]/) {
        $name1 =~ /^ *([A-Z])/;
        $myini = $1;
        $name2 =~ /^ *([A-Z])/;
        $myini = $myini . $1;
    } elsif ($name1 =~ /^ *[a-zA-Z]/ and $name2 =~ /^ *[a-zA-Z]/) {
        $name1 =~ /^ *([a-zA-Z])/;
        $myini = $1;
        $name2 =~ /^ *([a-zA-Z])/;
        $myini = uc($myini . $1);  
    } elsif ($name1 . $name2 =~ /[,;]/) {
		$myini = "?";
		print h1('Bitte geben Sie zwei Initialen aus Vor- und Nachname ein!');
	} elsif (($name1 . $name2 =~ tr/A-Z//) == ($name1 . $name2 =~ tr///c)) {
		$myini = $name1 . $name2;
		print h1('Die Initialen enthalten mehr als zwei Zeichen!') if ($name1 . $name2 =~ tr///c > 2);
	} elsif ($name1 =~ /^ *[^a-zA-Z]/) { 
		$myini = "?";
		print h1('Der Vorname beginnt mit einem unbekannten Zeichen!');
	} elsif ($name2 =~ /^ *[^a-zA-Z]/) { 
		$myini = "?";
		print h1('Der Nachname beginnt mit einem unbekannten Zeichen!');
	} else {
		$myini = "?";
		print h1('Bitte prfen Sie, ob Sie fr die Initalen Vor- und Nachname angegeben haben!');
	}
}
if ($jahr eq "mit") {
$myjahr	= $1 if localtime =~ /.*20([0-9][0-9])$/;
}

#if($var and $ags =~ /^15/) {
if($ags =~ /^15/) {
    $myags = $myags . "-";
    print h1('Code nach Landesregel Sachsen-Anhalt ohne Straenschlssel');
    print b('Warnung: In Sachsen-Anhalt wurde seit Mrz 2009 der Code umgestellt auf eine Variante mit Ortsteilkennzeichnung.');
    print "Der hier angezeigte Code ist daher nur eingeschrnkt gltig und entspricht nicht den aktuellen Vorgaben. Bitte setzen Sie sich direkt mit dem <a href=\"http://www.polizei.sachsen-anhalt.de/index.php?id=1651&MP=773-25\">Landeskriminalamt Sachsen-Anhalt</a> in Verbindung, wenn Sie verbindliche Ausknfte suchen.";
} elsif ($ags =~ /^09/ and $streetnr[0] =~ /[-A-Z]/) {
#    $myags = "0" if $myags eq "000";
#    $mykz = $mykz . "-"  if $myags eq "0" and $mykz =~ /O$/;
#    $streetnr[0] = "-" . $streetnr[0] if
#        $streetnr[0] =~ /^[0-9O]/;
#    $streetnr[0] = $streetnr[0] ."-" if
#        $streetnr[0] =~ /[0-9O]$/;
    ($myhsnr) = $myhsnr =~ /0*([1-9]*[0-9])$/;
    print h1('Code nach bayrischer Sonderregelung ohne Straenschlssel!');
} elsif ($ags =~ /^11/) {
    $myags = "-";
    print h1('Abweichend vom Berliner Standard mit Geburtsdatum:')
} elsif ($ags =~ /^02/) {
    $myags = "-";
}

#<table style="background-color: rgb(51, 0, 153); text-align: left; margin-left: auto; margin-right: auto;" cellpadding="2" cellspacing="1">
#<td style="text-align: center; vertical-align: top; color: rgb(255, 255, 0);"><small>
if (!$myhsnr or !$myini) {
	$tresult = table(
	Tr(td('KZ AGS'),td('STR')),
	Tr(td($kz),td($streetnr[0]))
	)  ;
} else {
	if ($myjahr) {
		$tresult = table({-align=>'center',border=>'1',cellspacing=>'0',
			style=>"background-color: rgb(10, 80, 161);
                        color: rgb(255, 255, 51)"},
		Tr({-align=>'center',-valign=>'top'},
		[
			td(['KZ', 'AGS',	'STR',	'HS',	'INI',	'Jahr']),
			td({-style=>"font-size:${text}em"},
				[$mykz,	$myags, $streetnr[0],	$myhsnr,	$myini,	$myjahr])
		])) . p({align=>'center'},
		radio_group(-name=>'jahr',-values=>["mit","ohne"],-default=>$jahr) 
		. " Jahreszahl; " .
		textfield(-name=>'text',-size=>2,-value=>$text)."x Textgre");
	} else {
		$tresult = table({-align=>'center',border=>'1',cellspacing=>'0',
					style=>"background-color: rgb(0, 0, 153);color: rgb(255, 255, 51)"},
		Tr({-align=>'center',-valign=>'top'},
		[
			td(['KZ', 'AGS',	'STR',	'HS',	'INI']),
			td({-style=>"font-size:${text}em"},
				[$mykz,	$myags,	$streetnr[0],	$myhsnr,	$myini])
		])) . p({align=>'center'},
		radio_group(-name=>'jahr',-values=>["mit","ohne"],-default=>$jahr) 
		. " Jahreszahl; " .
		textfield(-name=>'text',-size=>2,-value=>$text)."x Textgre");
	}
	
	print hr, $tresult;
}

return '1'  if  (!$myhsnr or !$myini);

print hr;

$myein=	$mykz . $myags . $streetnr[0] . $myhsnr . $myini . $myjahr;
$html_aufkleber_adfc =~ s/#EINCODE#/&nbsp;$myein&nbsp;/;
$html_aufkleber_polizei =~ s/#EINCODE#/$myein/;

print "<table><tr><td>";
print blockquote(
	"Die zugehrige Adresse von <b>$myein</b> lautet:");
	
$myini 	= $name1 . " " . $name2;
$myini 	=~ s/^([A-Z])(.* )([A-Z])([^ ]*$)/<b>$1<\/b>$2<b>$3<\/b>$4/;
$myhsnr	= $hsnr;
$myhsnr =~s/([0-9]+)(.*)/<b>$1<\/b>$2/;

print $n1,br,$n2,br,$myini,br,$hsnr,br,$myhsnr,br,$plz if $debug;

print blockquote(
	$myini . br . 
	$street[0]." ".$myhsnr. br . 
	($plz=~ /^[0-9]{5}$/?$plz." ":'').$ort. p)	;

print "</td>\n<td>", 
    $html_aufkleber_adfc, p, 
    $html_aufkleber_polizei,
    "</td></tr></table>";

return '2';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
### Ortssuche ###
sub search_ags { 
my ($name) = @_;
my $search = search_term($name);
my (@ort_srch);
my ($plz_srch);
my ($ii);
print "Suchbegriff: >$name<\n",p if $debug;
print "Suchbegriff: <$search>\n",p if $debug;
return ('') if !$name;
if ($search =~ /^\d{8}$/) { # AGS8
	print "suche nach AGS8 $search",p if $debug;
	$search =~ /^(\d{2})(\d{3})\d{3}/;
	print "Fr $search liegt noch kein Straenschlssel vor\n"
		if(! "$apath/$1/$1$2/$search");
	$i = 1;
	return $search;
} elsif ($search =~ /^([01]\d+)$/) { # AGS
	print "suche nach AGS $search",p  if $debug;
	open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
	$i = 0;
	<KEYA>;
	while(<KEYA>){
		($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
		$i++ if $ags[$i] =~	/^$1/;
		if ($i>20){
			$ags[$i] = $kz[$i] ='';	
			$ort[$i] = "Treffer 1-20.";
			$i++;
			last;
		}
	}
	close (KEYA);
} elsif ($name =~ tr/A-Z// == $name =~ tr///c and 
 $name =~ tr///c <= 3) { #Kennzeichen
	print "suche nach KZ $search",p if $debug;
	open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
	$i = 0;
	<KEYA>;
	while(<KEYA>){
		($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
		if ($kz[$i] =~	/^$name \d+$/o) {
			print $_ if $debug;
			$i++;
		}
		last	if $i>300;
	}
	close (KEYA);
} elsif ($name =~ tr/A-Z 0-9// == ($name =~ tr///c)
  and $name =~ /([A-Z]{1,3})[- ]*([0-9]{1,3})/ ) { #EIN
	print "suche nach KZ-000 $search",p if $debug;
	open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
	$i = 0;
	<KEYA>;
	while(<KEYA>){
		($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
		if ($kz[$i] =~	/^$1 $2$/) {
			print $_ if $debug;
			$i++;
		}
		last	if $i>300;
	}
	close (KEYA);
} else { # Ort
	print "suche nach Ort $search",p if $debug;;
	$plz_srch = $1 if $search =~ /^([0-9]{5})-/; # PLZ
	$search =~ s/$plz_srch-// if $plz_srch;
	$i = 0;
	if ($plz_srch) { # 1. PLZ und Ort passen
		print "suche nach PLZ $plz_srch, Ort $search",p if $debug;;
		open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
		<KEYA>;
		while(<KEYA>){ # 1. PLZ und Ort passen
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			$i++ if $plz[$i] =~ /$plz_srch/ and $ort_srch[$i] =~ /[- ]$search[- ]/;
			last	if $i>300;
		}
		close (KEYA);
		print "$.-$i: $name, $plz_srch $search",p if $debug;;
	}
	if ($plz_srch and $i == 0) { # 1.1 PLZ passt
		print "suche nach PLZ $plz_srch",p if $debug;;
		open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
		<KEYA>;
		while(<KEYA>){ # 1. PLZ
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			$i++ if $plz[$i] =~ /$plz_srch/;
			last	if $i>300;
		}
		close (KEYA);
		print "$.-$i: $name, $plz_srch $search",p if $debug;;
	} elsif (!$search) {
		return 0;
	}
	if($i == 0) { # 2. Ort passt
		print "suche nach Ort $search",p if $debug;;
		open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
		<KEYA>;
		while(<KEYA>){
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			print "$_\n" if $ort_srch[$i] =~ / $search / and $debug;
			$i++ if $ort_srch[$i] =~ / $search / ;
			last	if $i>300;
		}
		close (KEYA);
		print "$.-$i: $name, $search",p if $debug;;
	}
	if($i == 0) { # 3. Ortsanfang passt
		print "suche nach Ort $search*",p if $debug;;
		open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
		<KEYA>;
		while(<KEYA>){
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			$i++ if $ort_srch[$i] =~ / $search/ ;
			last	if $i>300;
		}
		close (KEYA);
		print "$.-$i: $name, $search",p if $debug;;
	}
	if($i == 0) { # Ort: Text enthalten
		print "suche nach Ort *$search*",p if $debug;;
		$search =~ s/^SANKT-//;
		$search =~ s/^ST-//;
		$search =~ s/^BAD-//;
		$search =~ s/-/.*/g;
		print "Suche nach Bestandteil $search im Ortsnamen\n",p if $debug;
		open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
		<KEYA>;
		while(<KEYA>){
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			$i++ if $ort_srch[$i] =~	/$search/;
			print "$_\n" if $debug>1;
			last	if $i>300;
		}
		close (KEYA);
		print "$.-$i: $name, $search",p if $debug;;
	}

}
if	($i==1){
	print hidden('ort',$ort[0]);
	print hidden('kz',$kz[0]);
	print hidden('ags',$ags[0]);
	$plz = $plz_srch;
	$kz = $kz[0];
	$ort = $ort[0];
	return $ags[0];
} else {
	Delete('$ort');
	Delete('$kz');
	Delete('$ags');
	$ort='';
	$kz='';
}
return '';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
### Ortsname eines AGS ###
sub getname {
my ($ags8) = @_;
return 0 if !$ags8;
my $ags5 = $ags8;
my $ags2 = $ags8;
my @ort_srch;
print "getname $ags8-$ags $kz $ort",p if $debug;
if ($ags5 =~ /^\d{5}$/  or $ags2 =~ /^\d\d$/) {
	print "Suche nach Bundesland/Kreis $ags8\n" if $debug;
	open (KEYA, $a5file) or die "Kein AGS-Verzeichnis gefunden",p;
	while(<KEYA>){
		print $_ if $debug;
		if (/^$ags8 *\t([^\t]*)/) {
			print "### $ags8:$_ - $1\n" if $debug;	
			return ($1);
		}
	}
	close(KEYA);
	return $ags8;
}
if (($ags8 ne $ags) or !$ort  or !$kz ) {
	open (KEYA, $afile) or die "Kein AGS-Verzeichnis gefunden",p;
	$i = 0;
	<KEYA>;
	while(<KEYA>){
		if (/^$ags8\t/) {
			($ags[$i], $ort_srch[$i], $ort[$i], $kz[$i], $plz[$i]) = split /[\t\n]/;
			$i++ if $i == 0 or $kz[$i] ne $kz[$i-1] ;
		}
		if ($i>20){
			$ags[$i] = $kz[$i] ='';	
			$ort[$i] = "Treffer 1-20.";
			$i++;
			last;
		}
	}
	close(KEYA);
}

print ($i,$ags[$i],$ort[$i]) if $debug;
if ($ags =~ tr/0-9// == 8 and $i <= 1) {
	print hidden('ort',$ort[0]);
	print hidden('kz',$kz[0]);
	print hidden('ags',$ags[0]);
	$kz = $kz[0];
	$ort = $ort[0];
} elsif ($ags =~ tr/0-9//) {
	Delete('ort');
	Delete('kz');
	Delete('ags');
	$ort='';
	$kz='';
}
return 0 if $i != 1;
return $ort[0];
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
### Strassensuche ###
sub search_keys {
my ($ags, $strasse) = @_;
my ($street2,$warn);
$i=0;
$var=0;

my $str_srch;
my $search = search_term($strasse);
$search =~ s/STRASSE/STR/;
return 0 if !$search;

print "<$ags> is not a valid ags" 
	if !($ags =~ /^(\d{2})(\d{3})\d{3}/);

print "$apath/$1/$1$2/$ags\n",p if $debug;
my $ags2 = "$apath/$1";
my $ags5 = $ags2 . "/$1$2";
my $ags8 = $ags5 . "/$ags";
if (!-d $ags2) {
	print "Fr Bundesland ".getname($1)." liegt noch kein Straenschlssel bereit\n",p;
	$var=2;
	}
elsif (!-d $ags5) {
	print "Fr Kreis ".getname($1.$2)." liegt noch kein Straenschlssel bereit\n",p;
	$var=5;
	}
elsif (!-r $ags8) {
	print "Fr Gemeinde $ags ".getname($ags)." liegt noch kein Straenschlssel bereit\n",p;
	$var=8;
}
# Landesschlssel statt Gemeindeschlssel 
#if (($var > 1) and ($ags2 =~ /\/15$/ or $ags2 =~ /\/09$/)) {
if (($var > 1) and ($ags2 =~ /\/15$/ )) {
    print "Suche in Landesschlssel $ags2.tab",p if $debug;
    $ags8 = $ags2 . ".tab";
} elsif ($var) {return;}
print "Suche nach $search",p if $debug;
open (KEYL, $ags8) or die;
$i = 0;
$_=<KEYL>;	#first line: #\t$ags\t$lines
# print "failure on ags $ags: $_\n" if !/$ags/ and !$var;
while (<KEYL>) {
	($street[$i], $street2, $status[$i], $streetnr[$i]) 
		= split /[\t\n]/;
	next if $status[$i] =~/4[0-9]/ or $status[$i] =~/22/;
	$str_srch = " ".search_term($street[$i])." ".search_term($street2)." ";
	$i++ if $str_srch =~ / $search /;
	#print "$.=$i $street[$i-1]\n";
	last if $i > 10;
};
if ($i == 0) {
open (KEYL, $ags8) or die;	#reset $. 
$_=<KEYL>;	#first line: #\t$ags\t$lines
while (<KEYL>) {
	($street[$i], $street2, $status[$i], $streetnr[$i]) 
		= split /[\t\n]/;
	next if $status[$i] =~/4[0-9]/ or $status[$i] =~/22/;
	$str_srch = " ".search_term($street[$i])." ".search_term($street2)." ";
	$i++ if $str_srch =~ / $search/;
	last if $i > 10;
}}
if ($i == 0) {
$search =~ s/^SANKT-//;
$search =~ s/^ST-//;
$search =~ s/-/.*/;
close (KEYL);
open (KEYL, $ags8) or die;	#reset $. 
$_=<KEYL>;	#first line: #\t$ags\t$lines
while (<KEYL>) {
	($street[$i], $street2, $status[$i], $streetnr[$i]) 
		= split /[\t\n]/;
	next if $status[$i] =~/4[0-9]/ or $status[$i] =~/22/;
	$str_srch = " ".search_term($street[$i])." ".search_term($street2)." ";
	$i++ if $str_srch =~ /$search/;
	#print "$.:$i $street[$i]\n" ;
	last if $i > 10;
}}
close (KEYL);
if ($i == 0) {
$search =~ s/[0-9]*$//;
$search =~ s/\.\*$//;
$search =~ s/STRASSE$//;
$search =~ s/STR\.$//;
$search =~ s/STR$//;
$search =~ s/WEG$//;
close (KEYL);
open (KEYL, $ags8) or die;	#reset $. 
$_=<KEYL>;	#first line: #\t$ags\t$lines
while (<KEYL>) {
	($street[$i], $street2, $status[$i], $streetnr[$i]) 
		= split /[\t\n]/;
	next if $status[$i] =~/4[0-9]/ or $status[$i] =~/22/;
	$str_srch = " ".search_term($street[$i])." ".search_term($street2)." ";
	$i++ if $str_srch =~ /$search/;
	# print "$.:$i $search within $street[$i]<br>\n" ;
	last if $i > 10;
}}
close (KEYL);


if($i >9) {
	print end_Tr(), start_Tr, td(),td({-colspan=>'3'},
	"Es wurden zu viele passende Strassen gefunden.",br,
		"Bitte schrnken Sie Ihre Suche ein.",hr);}
if($i > 1) {
	for ($ii = 0; $ii < $i; $ii++){
		$street[$ii] =~ s/([Ss])tr\./$1trae/;
		if ($ags=="02000000") {
		  if ($streetnr[$ii] =~ /^[A-Z]\d{3}/) {
		      $warn="";}
		  else {
		      $warn="Straennummer entspricht nicht Hamburger Standard";
		  }
		} elsif($streetnr[$ii] =~ /[^0-9]/ and !$ags =~ /^09/) {
		  $warn = "Straennummer enthlt nicht nur Zahlen";
		} elsif ($var) {
		  $warn = "Straennummer aus Landesliste";
		} else {
		   $warn = "";
		}
		print end_Tr(), start_Tr, td(b($kz)), 
			td(a({href=>url(-relative)."?".
					"ags=$ags;".
					"str=$street[$ii]".
					($hsnr?";hsnr=$hsnr":'').
					($name1?";n1=$name1":'').
					($name2?";n2=$name2":'')},
				).
				$street[$ii]),
			td($warn);
					# ohne  $streetnr[$ii]) . " " . vor street
		print "$streetnr[$ii],$street[$ii],$status[$i]\n" if $debug;
	}
} elsif ($i == 1) {
	$street[0] =~ s/([Ss])tr\./$1trae/;
	print td(b($kz)), 
		td(b($streetnr[0])." ".$street[0]);
}
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_new {
my ($ags, $strasse) = @_;
my	(@alines, $aags, $anr, $astr, $aplz, $aortsteil,$status) ;
my $ii;
$i=0;
my $search = search_term($strasse);
print "neue suche nach $search",p if $debug ;

open (NEWFILE, "$neufile") or return 0;
while (<NEWFILE>) {
	next if !/^\d+\t$ags\t/;
	($alines[$i], $aags, $anr, $astr, $aplz, $aortsteil) 
		= split /[\t\n]/,$_,5;
	$street[$i] = search_term($astr);
	print $_,p if $debug >1;
	if ($street[$i] =~ /$search/) {
		$street[$i] = $astr .
			($aortsteil?" ($aortsteil)":'');
		if ($anr =~ tr/0-9// < 5 and 
			$anr =~ tr/0-9// == $anr =~tr///c) {
			$streetnr[$i] = "00000$anr";
			$streetnr[$i] =~ s/^0*([0-9]{5})$/$1/;
		} else {
			$streetnr[$i] = $anr;
		}
		$i++;
		print "$search:$ags $anr $astr",p if $debug >1;

	}
	last if $i > 10;
}
close (NEWFILE);

if($i >9) {
	print end_Tr(), start_Tr, td(),td({-colspan=>'3'},
	"Es wurden zu viele passende Strassen gefunden.",br,
		"Bitte schrnken Sie Ihre Suche ein.",hr);}
if($i > 1) {
	for ($ii = 0; $ii < $i; $ii++){
		$street[$ii] =~ s/([Ss])tr\./$1trae/;
		print end_Tr(), start_Tr, td(b($kz)), 
			td(a({href=>url(-relative)."?".
					"ags=$ags;".
					"nr=$streetnr[$ii]".
					"str=$street[$ii]".
					($name1?";n1=$name1":'').
				    ($name2?";n2=$name2":'')},
					$streetnr[$ii]) . " " .
				$street[$ii]. " ".
				i(a({href=>url(-relative)."?".
					"use=$alines[$ii]"},
					"(unbesttigter Benutzereintrag)")));
		print "$streetnr[$ii],$street[$ii],$status[$i]\n" if $debug;
	}
} elsif ($i == 1) {
	$street[0] =~ s/([Ss])tr\./$1trae/;
	print td(b($kz)), 
		td(b($streetnr[0])." ".$street[0]. " ".
				i(a({href=>url(-relative)."?".
					"use=$alines[0]"},
					"(unbesttigter Benutzereintrag)")));
}

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #

sub splitkeys  {
my ($file) = @_;
my $ags5;
my $i40; # status is valid

print $file;
open (KEYA, "$file") or die "can not open $file\n";
$i = 0;
$i40 = 0;
$ags='';
while(<KEYA>){
	#$_=<KEYA>;
	#print $i . ": " . $_  . "\n";
	print $_."# input \n" if !/^(\d{2})(\d{3})(\d{3})\t/;
	if($i==0) {
		$ags5 = mkkeysdir($&);
	} elsif (($& != $ags[$i-1])) {
	    ($ags) = $ags[0] =~ /^(\d{8})$/;
		writekeys($ags5, $i) if $i40;
		$ags5 = mkkeysdir($&);
		$i40=0;
		$i=0;
	} 
	($ags[$i], $street[$i], $street2[$i], $streetnr[$i], $status[$i], $ortsteil[$i]) 
		= split /[\t\n]/
		or print "malformatted input line:\n\t".$_."\n";
	#print $i . "\t" . $street[$i]."\n";
	if ($streetnr[$i] =~ tr///c < 5) {
		$streetnr[$i] = "00000$streetnr[$i]" 
			if $streetnr[$i] =~ tr/0-9// == $streetnr[$i] =~ tr///c;
		$streetnr[$i] =~ s/^0*(\d{5})$/$1/;
	}
	$i40++ if !($status[$i] =~ /^4[0-9]/);
	$i++;
}
($ags) = $ags[0] =~ /^(\d{8})$/;
writekeys($ags5, $i);
close(KEYA);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub writekeys {
my  ($ags5, $i)=@_;
open (KEYL, ">". $ags5 . "/" . $ags) 
	or die "could not open $ags5/$ags: $!";
print KEYL "# ", $ags,"\t",$i,"\n";
for ($ii=0; $ii < $i; $ii++) {
	print KEYL
		$street[$ii] . "\t" . 
		$street2[$ii] . "\t" . 
		$status[$ii] . "\t" .
		$streetnr[$ii] . "\t" .
		$ortsteil[$ii] . "\n";
	}
close KEYL;
print $ags ."\t". $i ." lines\n";
return $i;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #

sub mkkeysdir {
my ($ags) = @_;
print "$ags is not a valid ags\n" if !/^(\d{2})(\d{3})\d{3}/;
my $ags2 = "$apath/$1";
my $ags5 = "$ags2/$1$2";
if (!-d $ags2) {
	mkdir $ags2 or die "could not create $ags2/";
	print "mkdir $ags2/ succeeded\n";
	}
if (!-d $ags5) {
	mkdir $ags5 or die "could not create $ags5/";
	print "mkdir $ags5/ succeeded\n";
	}
return $ags5;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub split_ags8 {
my ($file) = @_;
my $ii=$i=0;
my @Ort;
open (AFILE, $file) or die "can't open agsfil $file";
while (<AFILE>) {
    ($ags[$i], $ort[$i], $kz[$i], $plz[$i]) =
	split /[\t\n]/;

    unless( $kz[$i] =~ /^[A-Z]{1,3} *[0-9]{1,3}$/) {
	print "$_ ; ### strange kz code >$kz[$i]<\n";
	$ii++;
    }
    die "this is no useful ags file: \n" if $ii > 5000;

    ($ags[$i] =~ s/^([01]\d{7}).*/$1/) ?
	$i++ : print "$_ ; ## strange ags $ags[$i]\n";
}
close(AFILE);
open (AFILE, ">", $afile);
print AFILE  "# $i lines; ".time()."\n";
for($ii=0; $ii< $i; $ii++) {
    $Ort[$ii] = search_term($ort[$ii]);

#    $plz[$ii] =~ s/((\d+[,]){3}).*/$1\.\.\./;
    $plz[$ii] =~ s//,/g;
    
    print AFILE "$ags[$ii]\t $Ort[$ii] \t$ort[$ii]\t$kz[$ii]\t$plz[$ii]\n"
}
close (AFILE);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub search_term {
my ($my_expr) = @_;
#print "search_my_expr: $my_expr\n",p if $debug>1;
return '' if !$my_expr;
$my_expr =~ tr/a-z/A-ZAAAAAEEEEIIIIOOOOC/;
$my_expr =~ tr//AAAAEEEEIIIIOOOOC/;
$my_expr =~ s/(AE|)/AE/g;
$my_expr =~ s/(OE|)/OE/g;
$my_expr =~ s/(UE|)/UE/g;
$my_expr =~ s/(SS||S|SSS)/SS/g;
$my_expr =~ tr/-A-Z0-9/-/cs;
$my_expr =~ s/^[- ]*//;
$my_expr =~ s/[- ]*$//;
#$my_expr =~ s/^(.{,40})/$1/;
print "search_my_expr: ->$my_expr<-\n",p if $debug>1;
return $my_expr;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub access_log {

my	$ltime	= ''; # log time
my	$lip	= ''; # log ip
my	$ldom	= ''; # log domain
my	$cntd 	= 0;	# count per day
my  	$cntip 	= 0;	# count per ip
my	$cntdom	= 0;	# count per domain
my	$lday	= time() - 24*60*60;
my	$rip	= remote_host();
my	$dummy;
my	$lurl	= url(-query => 1);

$lurl = $lurl =~ s/;[^;]*=;/;/g;


print $lfile."\n" if $debug>9;
print time() . "\t$rip\t" . user_agent() . "\t" . referer() . query_string."\n" if $debug>9;

open (LOGFILE, ">> $lfile") or die "logfile not available: $!\n";
print LOGFILE time() . "\t$rip\t$name\t$ags\t$kz\t$ort\t$str\t$hsnr\t$name1\t$name2\t".
	url() . "\t". referer() . "\t" . user_agent() ."\t" . query_string . "\n";
#	$lurl . "\t". referer() . "\t" . user_agent() ."\t" . query_string . "\n";
close (LOGFILE);

if( $rip =~ /(\d{,3}\.){3}\d{,3}$/ or $rip =~ /(\d{,3}\.){5}\d{,3}$/) {
	$rip =~ s/^(\d+)\.(\d+)\.[\d\.]*$/$1\\.$2\\.[0-9\.]*\\\$/;
} elsif ($rip =~ /^([-a-zA-Z0-9]*\.)*[-a-zA-Z0-9]$/ ) {
	$rip =~ s/^([-a-zA-Z0-9]*\.)*([-a-zA-Z0-9]\.[-a-zA-Z])$/$2/;
}
print "$rip\n" if $debug>9;
open (LOGFILE, "< $lfile") or die "logfile unavailable\n";
while (<LOGFILE>) {
	($ltime, $lip, $dummy) = split /[\t\n]/;
	if ($ltime > $lday) {
		($ldom) = $lip =~ /^([0-9]*\.[0-9]*)\./;
		$cntdom++	if $rip =~ /^$ldom/;
		$cntip++	if $rip =~ /^$lip/;
		$cntd++;
	}
}
close (LOGFILE);
print "$rip: $lip:$cntip/$ldom:$cntdom/$cntd\n" if $debug;
print h1("berlastung - Bitte versuchen Sie es spter wieder<br>") if $cntip > 10;
print h1("berlastung - Bitte versuchen Sie es demnchst wieder<br>") if $cntdom > 100;
print h1("berlastung - Bitte versuchen Sie es morgen wieder<br>") if $cntd > 1000;


if($cntip > 10 or $cntdom > 100 or $cntd > 1000
	or ($cntip > 2 and user_agent() eq "Mozilla/4.0 (compatible; MSIE 6.0; Windows 98)" )) {
	open (ACCESSFILE, ">> ".$apath."/access.log") or die "logfile unavailable\n";
	print ACCESSFILE time() . "\t$rip\t$cntip\t$cntdom\t$cntd\t".query_string."\n";
	close (ACCESSFILE);
	}
	
return(0) if $rip =~ /http:\/\/localhost/ or $rip =~  /127.0.0.1/;
return(0) if $rip =~ /194.25.90.180/;
return(0) if $rip =~ /193.108.184.61/;
return(0) if $rip =~ /213.164.73.11/;
return(0) if $rip =~ /213.164.91.2/;
return(0) if $rip =~ /62.245.234.168/;
return(0) if $rip =~ /88.66.13.239/; # Karin, ADFC Mnchen
return(0) if $rip =~ /88.130.47.16/; # Alfred Linder

# return(1) if $rip =~ /^84\.6[12]\./ and $cntdom > 10;
return(1) if user_agent() eq "Mozilla/4.0 (compatible; MSIE 6.0; Windows 98)" and $cntip > 2;

sleep ($cntip^2) if $cntip > 3; # delay for repeated use

return($cntip > 10 or $cntdom > 100 or $cntd > 1000);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub success_log {


open (LOGFILE, ">> $sfile") or die "logfile  not available: $!\n";
print LOGFILE time() . "\t$i\t" .
    sprintf("%24s",($i?$street[0]:'')) .
    "\t$str\t$ags\t?str=$str;ags=$ags\n";
close (LOGFILE);

}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub init {
if(param('dbg')) {
	$debug = param('dbg');
	print "debug level = $debug\n",p if $debug>99;

}

$ags = param('ags');
my $ckags = cookie('ags');

$name = param('name');
my $ckort = cookie('ort');
#utf8::decode($ckort);
#$ckort = utf_decode($ckort);
$ckort =~ s/%20/ /g if $ckort;
$ckort = '' if $ckort =~/[A-Za-z0-9 ()\/]/;


$kz 	= param('kz');
my $ckkz = cookie('kz');
#utf8::decode($ckkz);
#$ckkz = utf_decode($ckkz);
$ckkz = '' if $ckkz =~/[A-Z0-9 ]/;

$ort	= param('ort');
$str	= param('str');
$hsnr	= param('hsnr');
$name1  = param('n1');
$name2  = param('n2');


if (!$ags and $ckags and (!$name or $name eq $ckort))
	{$ags = $ckags}
elsif ($name and ($name ne $ckort))
	{$ags=''; Delete('kz'); Delete('ort');Delete('ags')}
	
if ($ckags and $ags eq $ckags and !$name)
	{$ort = $ckort; $kz = $ckkz;}
#check for ags via cookies
if($ags and $kz) {
	$ckhags = cookie(-name =>'ags', -value=>$ags);
	$ckhort = cookie(-name =>'ort', -value=>$ort);
	$ckhkz 	= cookie(-name =>'kz' , -value=>$kz);
} 


$jahr = param('jahr')?param('jahr'):(cookie('jahr')?cookie('jahr'):'mit');
$ckhjahr = cookie(-name =>'jahr' , -value=>$jahr);

$text = param('text')?param('text'):(cookie('text')?cookie('text'):$text);
$ckhtext = cookie(-name =>'text' , -value=>$text);

$html_style ='
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta name="robots" content="index,follow">
<meta name="revisit-after" content="14 days">
<title>ADFC Fachausschuss Technik - EIN Code-Generator</title>
<base target="_top">
<link rel="stylesheet" type="text/css" href="../styles/styles.css" media="screen">
<link rel="stylesheet" type="text/css" href="../styles/druck.css" media="print">
</head>';
$html_header='
<body bgcolor="#ffffff" background="../img/home2.jpg">

<!-- config errmsg="Navigation nicht anzeigbar!"-->
<!-- include virtual="../navigation/navi.txt"-->
<!--adfc-logo.txt-->
<div style="position:relative; top:0px;left:0px;">
<table cellpadding=0 cellspacing=0 border=0 width="100%">
<tr>
<td height=105 valign="bottom" style="background-image:url(http://www.fa-technik.adfc.de/img/logo_neu2.gif);background-repeat:no-repeat;">
<a href="http://www.fa-technik.adfc.de/index.html"><img src="http://www.fa-technik.adfc.de/img/fa.gif" alt="Fachausschuss Technik" width=785 height=105 border=0></a></td>
</tr>
<tr><td><img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=32 height="10" alt="">
<span style="font-size:9px;">
<a href="http://www.adfc.de/" target="_blank">ADFC</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/">FA Technik</a> &gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Ratgeber/">Ratgeber</a>&nbsp;&gt;&gt;&nbsp;
<a href="http://www.fa-technik.adfc.de/Codierung/">Codierung</a>&nbsp;&gt;&gt;&nbsp;
</span></td></tr>
</table>
</div>

<div style="margin-left:32px;margin-right:10px;">
<table width="98%">
<tr>
<td class="ueberschrift">EIN Code-Generator</td>
</tr>
</table>
';
$html_footer='
<hr>
<address><a href="&#x004D;ailto&#x003A;code&#x0040;adfc-bw&#x002E;de">Martin Trautmann</a></address>
<p>

<!-- include virtual="../navigation/footer.txt"-->
</td>
</tr>
<tr>
<td>&nbsp;</td>
<td>
<div class="druck">
<img src="http://www.fa-technik.adfc.de/img/onebyone.gif" width=630 height=1 alt="">
</div>
<div class="nurdruck">
<hr>
<p><strong>Allgemeiner Deutscher Fahrrad-Club, Fachausschuss Technik - http://www.fa-technik.adfc.de
<!--#echo var="DOCUMENT_URI" --></strong></p>
</div>
</td>
</tr>
</table>
';
$html_aufkleber_adfc='
<table style="background-color: rgb(255, 255, 0);" border="0" cellpadding="0" cellspacing="0">
  <tbody>
    <tr>
      <td style="height: 50px; width: 35px;"></td>
      <td style="text-align: left; vertical-align: middle;">
        <font size="+2">
        <span style="font-family: Arial; font-weight: bold; color: rgb(10, 80, 161);">
        Finger weg!</span></font></td>
      <td rowspan="3" style="vertical-align: middle; color: rgb(0, 0, 153); width: 70px;">
      &nbsp;<img style="width: 60px; height: 73px;" alt="logo" src="Aufkleber/logo.gif">&nbsp;</td>
    </tr>
    <tr>
      <td> </td>
      <td style="text-align: center; vertical-align: middle; 
        background-color: rgb(10, 80, 161); height: 30px; width: 240px; 
        color: rgb(204, 204, 204); font-family: Courier New,Courier,monospace; font-weight: bold;">
        <big><big><span style="color: rgb(238, 238, 238);">
        #EINCODE#
        </span></big></big>
      </td>
    </tr>
    <tr>
      <td style="height: 24px;"></td>
      <td style="vertical-align: middle; color: rgb(255, 255, 255);">
      <span style="font-family: Courier New; font-weight: bold; color: rgb(10, 80, 161);">
      <a href=http://www.adfc.de/code>www.adfc.de/code</a></span></td>
    </tr>
  </tbody>
</table>';
$html_aufkleber_polizei='
<table style="text-align: left;" border="0" cellpadding="0" cellspacing="0">
  <tbody><tr>
 	<td style="background-image: url(Aufkleber/polizei11.gif); height: 95px; width: 26px;"></td>
	<td style="background-image: url(Aufkleber/polizei12.gif); height: 95px; width: 281px;"></td>
	<td style="background-image: url(Aufkleber/polizei13.gif); height: 95px; width: 148px;"></td>
  </tr>
  <tr>
    <td style="background-image: url(Aufkleber/polizei21.gif); height: 32px; width: 26px;"></td>
	<td style="text-align: center; font-family: Courier New,Courier,monospace; 
	  vertical-align: middle; font-weight: bold;">
	  <big><big>
        #EINCODE#
	  </big></big></td>
	<td style="background-image: url(Aufkleber/polizei23.gif); height: 32px; width: 148px;"></td>
  </tr>
  <tr>
    <td style="background-image: url(Aufkleber/polizei31.gif); height: 19px; width: 26px;"></td>
	<td style="background-image: url(Aufkleber/polizei32.gif); height: 19px; width: 281px;"></td>
	<td style="background-image: url(Aufkleber/polizei33.gif); height: 19px; width: 148px;"></td>
  </tr></tbody>
</table>';
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub utf_decode {
my ($my_expr) = @_;
$my_expr =~ s/ä//g;
$my_expr =~ s/ö//g;
$my_expr =~ s/ü//g;
$my_expr =~ s/\\x9f//g;
$my_expr =~ s/\\x84//g;
$my_expr =~ s/%C3%83%C2%B6//g;
$my_expr =~ s/%C3%B6//g;
$my_expr =~ s/\\x96//g;
$my_expr =~ s/\\x9c//g;
return($my_expr);
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub report_error {
my $error = cgi_error;
    if ($error) {
	print header(-status=>$error),
	      start_html('Problems'),
              h2('Request not processed'),
	      strong($error);
        exit 0;
	}
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub report_use {
my $use = param('use');
my ($alines,$aags,$anr,$astr,$aplz,$aortsteil,
	$aquelle,$aurl,$acomment,$adatum,
	$amail,$amailx,$aname,$anamex,$atime);
my $date;
return 0 if !$use;
open (NEWFILE, "$neufile") or return 0;
while (<NEWFILE>) {
	next if !/^$use\t/;
	($alines,$aags,$anr,$astr,$aplz,$aortsteil,
		$aquelle,$aurl,$acomment,$adatum,$amail,$amailx,$aname,$anamex,$atime)
		= split /[\t\n]/;
	last;
}
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                                localtime($atime);
$date = ($year+1900)."-". sprintf("%02d", $mon) ."-".
		sprintf("%02d", $mday);
close (NEWFILE);
print header('Benutzereingaben');
print start_table;
print Tr(td(['AGS', $aags]));
getname($aags);
print Tr(td(['KZ', $kz[0]]));
print Tr(td(['Ort', $ort[0]]));
print Tr(td(['PLZ', $aplz])) if $aplz;
print Tr(td(['Ortsteil', $aortsteil])) if $aortsteil;
print Tr(td(['Strae', $astr]));
print Tr(td(['Nummer', $anr]));
print Tr(td(['',hr()]));
if ($aurl and $aquelle) {
	print Tr(td(['Quelle',a({href=>$aurl},$aquelle)]));
} elsif ($aurl) {
	print Tr(td(['Quelle',a({href=>$aurl},$aurl)]));
} elsif ($aquelle) {
        print Tr(td(['Quelle',$aquelle]));
}
if ($acomment and ($aurl or $aquelle)) {
	print Tr(td(['',$acomment]));
} elsif ($acomment) {
	print Tr(td(['Quelle',$acomment]));
}
if (!$amailx and $amail and $aname and !$anamex) {
	print Tr(td(['Name',a({mailto=>$amail},$aname)]));
} elsif (!$amailx and $amail) {
	print Tr(td(['E-Mail',a({mailto=>$amail},$amail)]));
} elsif (!$anamex and $aname) {
	print Tr(td(['Name',$aname]));
} elsif ($amail) {
	print Tr(td(['Name', i('E-Mail bekannt')]));
} elsif ($name) {
	print Tr(td(['Name', i('Name bekannt')]));
} else {
	print Tr(td(['Name', i('Name unbekannt')]));
}
print Tr(td(['Datum', $date]));
print end_table,end_html; 
exit 0;
}
# ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ #
sub add_str {
my $alines;
my $aort;
my $neu;
return 0 if ($ags =~ tr/0-9//) != 8;
return 0 if !$kz;
return 0 if !$str;

$neu = 1 if !$neu;
print hr;
print "Sollten Sie aus anderen Quellen die richtige Codierung kennen, ".
	"so knnen Sie diese Daten unmittelbar hier eintragen:",p;
print start_table({-border=>'0',cellspacing=>'0',cellpadding=>'0'});
print	Tr(td({colspan=>2},hr));
print	Tr(td(),td("Straencode-Angaben"));
print	Tr(td(b($kz)), td(b($ort)));
if( $ags =~ tr/0-9// != 8 ){
	print Tr(td,td({style=>"color:red"}, 
		"Fr Ort $ort liegt kein Gemeindeschlssel vor. $ags"));
	$neu +=2;
}
if(!param('addort')) {
	$aort = $ort;
}
print	Tr(td(b('Ort')),td(textfield(-size=>50,-name=>'addort',-value=>$aort)));
my $astr = param('addstr')?param('addstr'):$str;
if($astr and  ($astr =~ tr/A-Z// == 0 )){
	print Tr(td,td({style=>"color:red"}, 
		"Der Straenname enthlt keine Gro-Klein-Schreibung."));
	$neu +=2;
}
if($astr and  $astr =~ tr/-A-Za-z0-9. '//c ){
	print Tr(td,td({style=>"color:red"}, 
		"Der Straenname enthlt Sonderzeichen. $astr"));
	$neu +=2;
}
print	Tr(td(b('Strae')),td(textfield(-size=>50,-name=>'addstr',-value=>$astr)));
my $anr=param('addnr');
if($anr and  $anr =~ tr/0-9//c ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Straennummer sollte nur aus Nummern bestehen. $anr"));
	$neu +=2;
}
if($anr and  $anr =~ tr/0-9// > 5 ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Straennummer enthlt mehr als fnf Nummern. $anr"));
	$neu +=2;
}
if($anr and  $anr =~ tr/0-9// < 5 and $anr =~ tr/0-9// == $anr =~ tr///c ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Straennummer enthlt weniger als fnf Nummern. $anr"));
	Delete('addnr');
	$anr = "0000$anr";
	$anr =~ s/^0*(\d{5})$/$1/;
	$neu +=2;
}
if($anr and  $anr =~ tr/ // > 0 ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Straennummer darf keine Leerzeichen enthalten. $anr"));
	$neu +=2;
}
if($anr and  $anr =~ /[^A-Z0-9]/ > 0 ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Straennummer darf nur Grobuchstaben und Nummern enthalten. $anr"));
	$neu +=2;
}
$neu += 3 if $anr;
print	Tr(td(b('Str.-Nr.')),td(textfield(-size=>50,-value=>$anr,-name=>'addnr')));
my $aplz = param('addplz');
if($aplz and  $aplz =~ tr/0-9// != 5 ){
	print Tr(td,td({style=>"color:red"}, 
		"Die Postleitzahl sollte aus genau fnf Nummern bestehen. $aplz"));
	$neu +=2;
}
print	Tr(td('PLZ'),td(textfield(-size=>50,-name=>'addplz',-value=>$aplz)));
my $aortsteil = param('addortsteil');
print	Tr(td('Ortsteil'),td(textfield(-size=>50,-name=>'addortsteil',-value=>$aortsteil)));
print	Tr(td({colspan=>2},hr));
print	Tr(td(),td("Herkunft der Daten"));
my $aquelle = param('addquelle');
print	Tr(td('Quelle'),td(textfield(-size=>50,-name=>'addquelle',-value=>$aquelle)));
my $aurl = param('addurl');
if ($aurl) {
	$aurl =~ s/%20/ /g ;
	print Tr(td,td({style=>"color:red"}, 
		"ungltige Zeichen in: $aurl")) if $aurl =~ tr/:;.\-=&\?\/a-zA-Z0-9//cd;
}
print	Tr(td('WWW'),td(textfield(-size=>50,-value=>$aurl,-name=>'addurl')));
my $adate = param('adddate');
print	Tr(td('Datum'),td(textfield(-size=>50,-name=>'adddate',-value=>$adate)));
my $acomment = param('addcomment');

print	Tr(td('Kommentar&nbsp;'),td(textfield(-size=>50,-name=>'addcomment',-value=>$acomment)));
print	Tr(td({colspan=>2},hr));
print	Tr(td(),td("Ihr Name"));
my $amail = param('addmail');
if ($amail and !($amail =~ /^[-_a-z0-9A-Z\.]+@([-a-z0-9A-Z]+\.)+([a-zA-Z)]+)$/)) {
	print Tr(td,td({style=>"color:red"}, 
		"Ist die E-Mail-Adresse richtig?"));
}
my $amailx = param('addsecmail');
print	Tr(td(b('E-Mail')),td(textfield(-size=>50,-name=>'addmail',-value=>$amail),
	checkbox(-name=>'addsecmail',-value=>'1',-label=>'nicht anzeigen')));
my $aname = param('addautor');
my $anamex = param('addsecname');
print	Tr(td('Name'),td(textfield(-size=>50,-name=>'addautor',-value=>$aname),
	checkbox(-name=>'addsecname',-value=>'1',-label=>'nicht anzeigen')));
my $aok=param('addok');
Delete('addok','neu') if $aok != $neu;
print	Tr(td,td(submit(-name=> ($aok==$neu)?'speichern':'prfen'),
	checkbox(-name=>'addok',-value=>$neu,-label=>'Daten ok')));
print end_table();
print hidden(-name=>'neu',-value=>$neu);

print "$neu: $aok\n",p if $debug;

##### schreibe Daten ins neufile ####
if($aok == $neu) {
print "$neu: schreibe nach $neufile\n",p if $debug;
my $avalid = "[^-A-Za-z0-9,\.;\/() _]";
$astr	=~ s/$avalid//g;
$anr	=~ s/$avalid//g;
$anr	=~ tr/a-z/A-Z/;
$aplz	=~ s/$avalid//g;
$aortsteil	=~ s/$avalid//g;
$aquelle	=~ s/$avalid//g;
# $aurl
$acomment	=~ s/$avalid//g;
$adate	=~ s/$avalid//g;
$amail	=~ s/[^-a-zA-Z0-9.@]//g;
$amailx	=~ s/\D//g;
$aname	=~ s/$avalid//g;
$amailx	=~ s/\D//g;

print "$ags:$astr:$anr:$amail \n",p if $debug;

open (NEWFILE, "$neufile");
while (<NEWFILE>) {
	($alines) = /^(\d+)\t/;	# get line number
}
close (NEWFILE);
print "$alines Zeilen in $neufile\n",p if $debug;
$alines++;

open (NEWFILE, ">> $neufile") or die "user defined file unavailable: $!\n";
print NEWFILE "$alines\t$ags\t$anr\t$astr\t$aplz\t$aortsteil\t".
	"$aquelle\t$aurl\t$acomment\t$adate\t".
	"$amail\t$amailx\t$aname\t$anamex\t".
	time() . "\t".remote_host()."\t" . user_agent() . "\t" . query_string() . "\n";
close (NEWFILE);
print "Daten wurden gespeichert",p;
}

}
